'
' Skeleton.BAS - Bare-bones file for building a UserFace application.
'
' UserFace (C) 1991 by Brent Ashley
'
DECLARE SUB InitMenus (Bar$, Menu$())
DECLARE SUB MainLoop (KeyIn$)
DECLARE SUB MonoTest ()
DECLARE SUB UserFaceMgr (Fore%, Back%, Hilite%)
DECLARE FUNCTION Dispatch% (MenuChoice%)

' $INCLUDE: 'UserFace.BI'
DEFINT A-Z

' ensure 0-based array subscripts
OPTION BASE 0

' set up shared variables - If you dimension Menu$ to
' only the dimensions needed, you will save memory.
DIM SHARED Menu$(12, 15, 1)
DIM SHARED Fore, Back, Hilite, WorkFore, WorkBack
CONST Title = "Your title here"

' check for mono adapter and error out if found
MonoTest

' init colors
Fore = 0: Back = 3: Hilite = 15: WorkFore = 7: WorkBack = 1

' init screen
CLS : ClearWorkSpace WorkFore, WorkBack, Fore, Back, Title

' Let the Pro take over...
UserFaceMgr Fore, Back, Hilite

' clean up
COLOR 7, 0: CLS

FUNCTION Dispatch (MenuChoice)
  '
  ' This is the Dispatch function programmed by YOU.
  '
  ' It dispatches the menu choices to your routines
  ' and returns 0 to quit UserFaceMgr
 
  ' default return code to 1
  Dispatch = 1
  SELECT CASE MenuChoice
      
    CASE 0 ' <Esc> pressed
      ' do nothing, for instance

    CASE ELSE
    
  END SELECT
END FUNCTION

SUB InitMenus (Bar$, Menu$())
  '
  ' This is where the UserFace menus are defined
  '

  ' define bar menu - each item must start with a capital letter
  ' item 1 should be at least 4 spaces in from the left and items
  ' should be separated by two spaces.
  '
  '                1         2         3         4         5         6         7         8
  '       12345678901234567890123456789012345678901234567890123456789012345678901234567890
  Bar$ = "   File  Edit  View  Search  Run  Debug  Calls  Options                   Help  "
 
  ' define number of menu items by making item 0 NumberOfItems in length
  Menu$(1, 0, 0) = SPACE$(1)
  ' define first menu item padded on right to full width of popup
  ' subsequent items need no padding.
  ' make sure there is at least one capital letter, and that there are no
  ' duplicate first capital letters in this menu
  ' null string means dividing line

  Menu$(1, 1, 0) = "Example   "

  ' define line 25 help text for item
  Menu$(1, 1, 1) = "Example Help Text"

  '... etc

END SUB

SUB MainLoop (KeyIn$)

  ' This is where you put the foreground program that
  ' runs until the menu is called.  KeyIn$ = "" on first entry,
  ' so if you put your KeyIn$=INKEY$ BEFORE the case block,
  ' you'll get first crack at the input, but you can put it
  ' AFTER the case block to give UserFaceMgr the first look
  ' at it.
  '

  KeyIn$ = WaitForKey$

  SELECT CASE KeyIn$
   
    ' process user program input
   
    ' process alternate menu choice combinations
   
    CASE ELSE
      ' whatever
  END SELECT

END SUB

SUB MonoTest
  ' test current video mode at 0000:0449 - if 7, it's mono.
  DEF SEG = 0
  IF PEEK(&H449) = 7 THEN
    COLOR 7, 0
    PRINT "This program does not work with monochrome adapters."
    PRINT "If you have a CGA, EGA, or VGA, make sure your video"
    PRINT "mode is set to colour by using MODE CO80 from DOS and"
    PRINT "then run this program again."
    END
  END IF
END SUB

SUB UserFaceMgr (Fore, Back, Hilite)
  '
  ' This is the main control centre for the UserFace user interface.
  ' While you can build your own, this example has been designed to
  ' be flexible enough that you will probably want to simply include
  ' it in every UserFace program.
  '
  ' UserFaceMgr requires that you have the following routines defined
  ' in your program:
  '
  ' SUB InitMenus (Bar$, Menu$())
  ' SUB MainLoop (KeyIn$)
  ' FUNCTION Dispatch% (MenuChoice%)
  '
  ' See the documentation or the UFDemo example program for more info.
  '
  STATIC OpenMenu, Continue, BarTot, HotKeys$

  ' set up menu data and init top and bottom screen lines
  InitMenus Bar$, Menu$()
  ParseBar Bar$, BarTot, HotKeys$
  ShowMenu Fore, Back, Bar$

  OpenMenu = 0
  Continue = 1
  KeyIn$ = ""
  DO
    ' run user program main loop
    MainLoop KeyIn$
  
    ' check if menu called
    IF MenuRequested(KeyIn$, HotKeys$, OpenMenu) THEN
      ' get menu choice and process
      Choice = UserFaceMenu(Fore, Back, Hilite, Bar$, BarTot, Menu$(), OpenMenu)
      Continue = Dispatch(Choice)
    END IF

  LOOP WHILE Continue
END SUB

