'
' UFDemo.BAS - UserFace QuickBASIC User Interface Library Demonstration
'
' (C) 1991 by Brent Ashley
'
' This demo program will show how you can set up your own programs
' to use UserFace's slick, professional-looking user interface.
'
DECLARE SUB InitMenus (Bar$, Menu$())
DECLARE SUB MainLoop (KeyIn$)
DECLARE SUB MonoTest ()
DECLARE SUB UserFaceMgr (Fore%, Back%, Hilite%)
DECLARE FUNCTION Dispatch% (MenuChoice%)

' $INCLUDE: 'UserFace.BI'
DEFINT A-Z

' ensure 0-based array subscripts
OPTION BASE 0

' set up shared variables - If you dimension Menu$ to
' only the dimensions needed, you will save memory.
DIM SHARED Menu$(9, 14, 1)
DIM SHARED Fore, Back, Hilite, WorkFore, WorkBack
CONST Title = "QuickBASIC User Interface Demo"

' check for mono adapter and error out if found
MonoTest

' init colors
Fore = 0: Back = 3: Hilite = 15: WorkFore = 7: WorkBack = 1

' init screen
CLS : ClearWorkSpace WorkFore, WorkBack, Fore, Back, Title

' display message
COLOR Fore, Back
SLBox 8, 18, 16, 62, 0
LOCATE 10, 23: PRINT "UserFace - (C) 1991 By Brent Ashley"
LOCATE 12, 21: PRINT "QuickBASIC User Interface Tools Library"
LOCATE 14, 28: PRINT "<Alt-F>,<X> exits Demo"

' Let the Pro take over...
UserFaceMgr Fore, Back, Hilite

' clean up
COLOR 7, 0: CLS
PRINT "Bye!!"

FUNCTION Dispatch (MenuChoice)
  '
  ' This is the Dispatch function programmed by YOU.
  '
  ' It dispatches the menu choices to your routines
  ' and returns 0 to quit UserFaceMgr
 
  ' default return code to 1
  Dispatch = 1
  SELECT CASE MenuChoice
      
    CASE 114 ' bar 1, pop 14 (file,exit)
      Dispatch = 0
    
    CASE 0 ' <Esc> pressed
      ' do nothing

    CASE 113 ' DOS shell
      '
      ' explicitly save to video page 3 in case any programs use page 1,2
      '
      ' CAUTION: any programs that write to screen page 3 will cause the
      '          screen not to return to its previous state...
      '
      PCOPY 0, 3
      COLOR 7, 0: CLS
      PRINT "Type EXIT to return to program."
      SHELL
      PCOPY 3, 0

    CASE ELSE
      ' display selection
      Msg$ = " You selected - Bar:" + STR$(MenuChoice \ 100) + " Drop:" + STR$(MenuChoice MOD 100) + " "
      OKPanel 10, 20, Fore, Back, Hilite, Msg$
    
  END SELECT
END FUNCTION

SUB InitMenus (Bar$, Menu$())
  '
  ' This is where the UserFace menus are defined
  '
 
  ' ensure local scope
  STATIC F1Prompt$
  ' define help prefix string if desired
  F1Prompt$ = " F1=Help " + CHR$(179) + " "

  ' define bar menu - each item must start with a capital letter
  ' item 1 should be at least 4 spaces in from the left and items
  ' should be separated by two spaces.
  '
  '                1         2         3         4         5         6         7         8
  '       12345678901234567890123456789012345678901234567890123456789012345678901234567890
  Bar$ = "   File  Edit  View  Search  Run  Debug  Calls  Options                   Help  "
 
  ' define number of menu items by making item 0 NumberOfItems in length
  Menu$(1, 0, 0) = SPACE$(14)
  ' define first menu item padded on right to full width of popup
  ' subsequent items need no padding.
  ' make sure there is at least one capital letter, and that there are no
  ' duplicate first capital letters in this menu
  '
  Menu$(1, 1, 0) = "New              "
  ' define line 25 help text for item
  Menu$(1, 1, 1) = F1Prompt$ + "Removes currently loaded program from memory"
  Menu$(1, 2, 0) = "Open Program..."
  Menu$(1, 2, 1) = F1Prompt$ + "Loads new program into memory"
  Menu$(1, 3, 0) = "Merge"
  Menu$(1, 3, 1) = F1Prompt$ + "Inserts specified file into current module"
  Menu$(1, 4, 0) = "Save"
  Menu$(1, 4, 1) = F1Prompt$ + "Writes current module to file on disk"
  Menu$(1, 5, 0) = "save As..."
  Menu$(1, 5, 1) = F1Prompt$ + "Saves current module with specified name and format"
  Menu$(1, 6, 0) = "saVe all"
  Menu$(1, 6, 1) = F1Prompt$ + "Writes all currently loaded modules to files on disk"
  ' null item creates dividing line
  Menu$(1, 7, 0) = ""
  Menu$(1, 8, 0) = "Create File..."
  Menu$(1, 8, 1) = F1Prompt$ + "Creates a module, include file, or document; retains loaded modules"
  Menu$(1, 9, 0) = "Load File..."
  Menu$(1, 9, 1) = F1Prompt$ + "Loads a module, include file, or document; retains loaded modules"
  Menu$(1, 10, 0) = "Unload File..."
  Menu$(1, 10, 1) = F1Prompt$ + "Removes a loaded module,include file, or document from memory"
  Menu$(1, 11, 0) = ""
  Menu$(1, 12, 0) = "Print..."
  Menu$(1, 12, 1) = F1Prompt$ + "Prints specified text or module"
  Menu$(1, 13, 0) = "Dos Shell  Ctrl+D"
  Menu$(1, 13, 1) = F1Prompt$ + "Temporarily suspends DEMO and invokes DOS shell"
  Menu$(1, 14, 0) = "eXit"
  Menu$(1, 14, 1) = F1Prompt$ + "Exits DEMO and returns to DOS"

  Menu$(2, 0, 0) = SPACE$(8)
  Menu$(2, 1, 0) = "Undo   Alt+Backspace"
  Menu$(2, 2, 0) = "cuT        Shift+Del"
  Menu$(2, 3, 0) = "Copy        Ctrl+Ins"
  Menu$(2, 4, 0) = "Paste      Shift+Ins"
  Menu$(2, 5, 0) = "cLear            Del"
  Menu$(2, 6, 0) = ""
  Menu$(2, 7, 0) = "new Sub..."
  Menu$(2, 8, 0) = "new Function..."

  Menu$(3, 0, 0) = SPACE$(9)
  Menu$(3, 1, 0) = "Subs...             F2"
  Menu$(3, 2, 0) = "nExt Sub      Shift+F2"
  Menu$(3, 3, 0) = "sPlit"
  Menu$(3, 4, 0) = ""
  Menu$(3, 5, 0) = "Next Statement"
  Menu$(3, 6, 0) = "oUtput Screen       F4"
  Menu$(3, 7, 0) = ""
  Menu$(3, 8, 0) = "Included file"
  Menu$(3, 9, 0) = "included Lines"
              
  Menu$(4, 0, 0) = SPACE$(5)
  Menu$(4, 1, 0) = "Find...                "
  Menu$(4, 2, 0) = "Selected Text    Ctrl+\"
  Menu$(4, 3, 0) = "Repeat Last Find     F3"
  Menu$(4, 4, 0) = "Change..."
  Menu$(4, 5, 0) = "Label..."
            
  Menu$(5, 0, 0) = SPACE$(9)
  Menu$(5, 1, 0) = "Start      Shift+F5"
  Menu$(5, 2, 0) = "Restart"
  Menu$(5, 3, 0) = "cOntinue         F5"
  Menu$(5, 4, 0) = "modify COMMAND$..."
  Menu$(5, 5, 0) = ""
  Menu$(5, 6, 0) = "make eXe File..."
  Menu$(5, 7, 0) = "make Library..."
  Menu$(5, 8, 0) = ""
  Menu$(5, 9, 0) = "set Main Module..."

  Menu$(6, 0, 0) = SPACE$(13)
  Menu$(6, 1, 0) = "Add Watch                  "
  Menu$(6, 2, 0) = "Instant Watch      Shift+F9"
  Menu$(6, 3, 0) = "Watchpoint..."
  Menu$(6, 4, 0) = "Delete Watch..."
  Menu$(6, 5, 0) = "deLete All Watch"
  Menu$(6, 6, 0) = ""
  Menu$(6, 7, 0) = "Trace On"
  Menu$(6, 8, 0) = "History On"
  Menu$(6, 9, 0) = ""
  Menu$(6, 10, 0) = "toggle Breakpoint        F9"
  Menu$(6, 11, 0) = "Clear All Breakpoints"
  Menu$(6, 12, 0) = "break on Errors"
  Menu$(6, 13, 0) = "Set Next Statement"
 
  Menu$(7, 0, 0) = SPACE$(1)
  Menu$(7, 1, 0) = "SaaTest.BAS"

  Menu$(8, 0, 0) = SPACE$(5)
  Menu$(8, 1, 0) = "Display...     "
  Menu$(8, 2, 0) = "set Paths..."
  Menu$(8, 3, 0) = "right Mouse..."
  Menu$(8, 4, 0) = "Syntax Checking"
  Menu$(8, 5, 0) = "Full Menus"
            
  Menu$(9, 0, 0) = SPACE$(4)
  Menu$(9, 1, 0) = "Index                   "
  Menu$(9, 2, 0) = "Contents"
  Menu$(9, 3, 0) = "Topic                 F1"
  Menu$(9, 4, 0) = "Help on Help    Shift+F1"

END SUB

SUB MainLoop (KeyIn$)

  ' This is where you put the foreground program that
  ' runs until the menu is called.  KeyIn$ = "" on first entry,
  ' so if you put your KeyIn$=INKEY$ BEFORE the case block,
  ' you'll get first crack at the input, but you can put it
  ' AFTER the case block to give UserFaceMgr the first look
  ' at it.
  '
  ' The demo program moves a little box around the screen as its main
  ' purpose
  '
  STATIC CurTop, CurLft
 
  IF CurTop = 0 THEN
    ' initialize first time through
    CurTop = 15: CurLft = 30
  ELSE
    ' only restore screen after first time through
    ignore = ScreenStack(0)
  END IF
 
  ignore = ScreenStack(1)

  ' display happy little movable box
  COLOR Fore, Back
  SLBox CurTop, CurLft, CurTop + 4, CurLft + 20, 1
  LOCATE CurTop + 2, CurLft + 4
  PRINT "Move me! "; CHR$(24); CHR$(25); CHR$(26); CHR$(27)

  KeyIn$ = WaitForKey$

  SELECT CASE KeyIn$
    ' process user program input
    CASE CHR$(0) + "H" 'up
      IF CurTop > 3 THEN CurTop = CurTop - 1
   
    CASE CHR$(0) + "P" 'down
      IF CurTop < 20 THEN CurTop = CurTop + 1
   
    CASE CHR$(0) + "K" 'left
      IF CurLft > 2 THEN CurLft = CurLft - 1
   
    CASE CHR$(0) + "M" 'right
      IF CurLft < 58 THEN CurLft = CurLft + 1
   
    CASE CHR$(0) + "G" 'home
      CurTop = 3: CurLft = 2
   
    CASE CHR$(0) + "O" 'end
      CurTop = 20: CurLft = 2
   
    CASE CHR$(0) + "I" 'pgup
      CurTop = 3: CurLft = 58
   
    CASE CHR$(0) + "Q" 'pgdn
      CurTop = 20: CurLft = 58
   
    ' alternate menu choice combinations
    CASE CHR$(4) ' Ctrl-D is an alternate combination for DOS Shell
      '
      ' simulate Alt-F,D sequence
      '
      ignore = Dispatch(113)
   
    CASE ELSE
      ' whatever
  END SELECT

  ' at this point, control transfers back to UserFaceMgr, which
  ' sees if KeyIn$ is a menu request, calls the menus if so, and
  ' then re-calls this routine.
END SUB

SUB MonoTest
  ' check video mode at 0000:0449 and if it's 7, a mono adapter
  ' is installed or MODE MONO is in effect.
  DEF SEG = 0
  IF PEEK(&H449) = 7 THEN
    COLOR 7, 0
    PRINT "This program does not work with monochrome adapters."
    PRINT "If you have a CGA, EGA, or VGA, make sure your video"
    PRINT "mode is set to colour by using MODE CO80 from DOS and"
    PRINT "then run this program again."
    END
  END IF
  DEF SEG
END SUB

SUB UserFaceMgr (Fore, Back, Hilite)
  '
  ' This is the main control centre for the UserFace user interface.
  ' While you can build your own, this example has been designed to
  ' be flexible enough that you will probably want to simply include
  ' it in every UserFace program.
  '
  ' UserFaceMgr requires that you have the following routines defined
  ' in your program:
  '
  ' SUB InitMenus (Bar$, Menu$())
  ' SUB MainLoop (KeyIn$)
  ' FUNCTION Dispatch% (MenuChoice%)
  '
  ' See the documentation or the UFDemo example program for more info.
  '
  STATIC OpenMenu, Continue, BarTot, HotKeys$

  ' set up menu data and init top and bottom screen lines
  InitMenus Bar$, Menu$()
  ParseBar Bar$, BarTot, HotKeys$
  ShowMenu Fore, Back, Bar$

  OpenMenu = 0
  Continue = 1
  KeyIn$ = ""
  DO
    ' run user program main loop
    MainLoop KeyIn$
  
    ' check if menu called
    IF MenuRequested(KeyIn$, HotKeys$, OpenMenu) THEN
      ' get menu choice and process
      Choice = UserFaceMenu(Fore, Back, Hilite, Bar$, BarTot, Menu$(), OpenMenu)
      Continue = Dispatch(Choice)
    END IF

  LOOP WHILE Continue
END SUB

